/// @cond EO_CXX_EO_IMPL

inline ::elm::widget_item elm::popup::item_append(::efl::eina::string_view label_, ::evas::object icon_, Evas_Smart_Cb func_, const void * data_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_popup_item_append(::efl::eolian::to_c(label_), ::efl::eolian::to_c(icon_), func_, data_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::popup::align_get(double* horizontal_, double* vertical_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_popup_align_get(horizontal_, vertical_));
}

inline void elm::popup::align_set(double horizontal_, double vertical_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_popup_align_set(horizontal_, vertical_));
}

inline bool elm::popup::allow_events_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_popup_allow_events_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::popup::allow_events_set(bool allow_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_popup_allow_events_set(::efl::eolian::to_c(allow_)));
}

inline Elm_Wrap_Type elm::popup::content_text_wrap_type_get() const
{
   Elm_Wrap_Type _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_popup_content_text_wrap_type_get());
   return _tmp_ret;
}

inline void elm::popup::content_text_wrap_type_set(Elm_Wrap_Type wrap_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_popup_content_text_wrap_type_set(wrap_));
}

inline Elm_Popup_Orient elm::popup::orient_get() const
{
   Elm_Popup_Orient _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_popup_orient_get());
   return _tmp_ret;
}

inline void elm::popup::orient_set(Elm_Popup_Orient orient_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_popup_orient_set(orient_));
}

inline double elm::popup::timeout_get() const
{
   double _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_popup_timeout_get());
   return _tmp_ret;
}

inline void elm::popup::timeout_set(double timeout_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_popup_timeout_set(timeout_));
}

inline bool elm::popup::scrollable_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_popup_scrollable_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::popup::scrollable_set(bool scroll_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_popup_scrollable_set(::efl::eolian::to_c(scroll_)));
}

inline ::elm::widget_item eo_cxx::elm::popup::item_append(::efl::eina::string_view label_, ::evas::object icon_, Evas_Smart_Cb func_, const void * data_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_popup_item_append(::efl::eolian::to_c(label_), ::efl::eolian::to_c(icon_), func_, data_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::popup::align_get(double* horizontal_, double* vertical_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_popup_align_get(horizontal_, vertical_));
}

inline void eo_cxx::elm::popup::align_set(double horizontal_, double vertical_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_popup_align_set(horizontal_, vertical_));
}

inline bool eo_cxx::elm::popup::allow_events_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_popup_allow_events_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::popup::allow_events_set(bool allow_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_popup_allow_events_set(::efl::eolian::to_c(allow_)));
}

inline Elm_Wrap_Type eo_cxx::elm::popup::content_text_wrap_type_get() const
{
   Elm_Wrap_Type _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_popup_content_text_wrap_type_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::popup::content_text_wrap_type_set(Elm_Wrap_Type wrap_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_popup_content_text_wrap_type_set(wrap_));
}

inline Elm_Popup_Orient eo_cxx::elm::popup::orient_get() const
{
   Elm_Popup_Orient _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_popup_orient_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::popup::orient_set(Elm_Popup_Orient orient_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_popup_orient_set(orient_));
}

inline double eo_cxx::elm::popup::timeout_get() const
{
   double _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_popup_timeout_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::popup::timeout_set(double timeout_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_popup_timeout_set(timeout_));
}

inline bool eo_cxx::elm::popup::scrollable_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_popup_scrollable_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::popup::scrollable_set(bool scroll_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_popup_scrollable_set(::efl::eolian::to_c(scroll_)));
}

inline ::eo_cxx::elm::popup::operator ::elm::popup() const
{
   return *static_cast<::elm::popup const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm::popup::operator ::elm::popup&()
{
   return *static_cast<::elm::popup*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm::popup::operator ::elm::popup const&() const
{
   return *static_cast<::elm::popup const*>(static_cast<void const*>(this));
}

template <typename T>
::elm::widget_item elm_popup_item_append_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * label_, Evas_Object * icon_, Evas_Smart_Cb func_, const void * data_)
{
   try
      {
         return static_cast<T*>(self->this_)->item_append(::efl::eolian::to_cxx<::efl::eina::string_view>(label_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<::evas::object>(icon_, std::tuple<std::false_type>()), func_, data_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_popup_align_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, double* horizontal_, double* vertical_)
{
   try
      {
         static_cast<T*>(self->this_)->align_get(horizontal_, vertical_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_popup_align_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, double horizontal_, double vertical_)
{
   try
      {
         static_cast<T*>(self->this_)->align_set(horizontal_, vertical_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_popup_allow_events_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->allow_events_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_popup_allow_events_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool allow_)
{
   try
      {
         static_cast<T*>(self->this_)->allow_events_set(::efl::eolian::to_cxx<bool>(allow_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Elm_Wrap_Type elm_popup_content_text_wrap_type_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->content_text_wrap_type_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Wrap_Type _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_popup_content_text_wrap_type_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Wrap_Type wrap_)
{
   try
      {
         static_cast<T*>(self->this_)->content_text_wrap_type_set(wrap_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Elm_Popup_Orient elm_popup_orient_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->orient_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Popup_Orient _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_popup_orient_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Popup_Orient orient_)
{
   try
      {
         static_cast<T*>(self->this_)->orient_set(orient_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
double elm_popup_timeout_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->timeout_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         double _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_popup_timeout_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, double timeout_)
{
   try
      {
         static_cast<T*>(self->this_)->timeout_set(timeout_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_popup_scrollable_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->scrollable_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_popup_scrollable_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool scroll_)
{
   try
      {
         static_cast<T*>(self->this_)->scrollable_set(::efl::eolian::to_cxx<bool>(scroll_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm::popup >
{
   template <typename T>
   struct type
         : virtual operations< ::elm::layout >::template type<T>
         , virtual operations< ::elm_interface_atspi_widget_action >::template type<T>
   {
      virtual ::elm::widget_item item_append(::efl::eina::string_view label_, ::evas::object icon_, Evas_Smart_Cb func_, const void * data_)
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_popup_item_append(::efl::eolian::to_c(label_), ::efl::eolian::to_c(icon_), func_, data_));
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void align_get(double* horizontal_, double* vertical_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_popup_align_get(horizontal_, vertical_));
      }

      virtual void align_set(double horizontal_, double vertical_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_popup_align_set(horizontal_, vertical_));
      }

      virtual bool allow_events_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_popup_allow_events_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void allow_events_set(bool allow_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_popup_allow_events_set(::efl::eolian::to_c(allow_)));
      }

      virtual Elm_Wrap_Type content_text_wrap_type_get()
      {
         Elm_Wrap_Type _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_popup_content_text_wrap_type_get());
            return _tmp_ret;
      }

      virtual void content_text_wrap_type_set(Elm_Wrap_Type wrap_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_popup_content_text_wrap_type_set(wrap_));
      }

      virtual Elm_Popup_Orient orient_get()
      {
         Elm_Popup_Orient _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_popup_orient_get());
            return _tmp_ret;
      }

      virtual void orient_set(Elm_Popup_Orient orient_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_popup_orient_set(orient_));
      }

      virtual double timeout_get()
      {
         double _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_popup_timeout_get());
            return _tmp_ret;
      }

      virtual void timeout_set(double timeout_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_popup_timeout_set(timeout_));
      }

      virtual bool scrollable_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_popup_scrollable_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void scrollable_set(bool scroll_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_popup_scrollable_set(::efl::eolian::to_c(scroll_)));
      }

   };
};


template<>
struct operation_description_class_size< ::elm::popup >
{
   static constexpr int value = 
#if defined(POPUP_PROTECTED) && defined(POPUP_BETA)
      13
#elif defined(POPUP_PROTECTED)
      13
#elif defined(POPUP_BETA)
      13
#else
      13
#endif
      + operation_description_class_size<::elm::layout >::value      + operation_description_class_size<::elm_interface_atspi_widget_action >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm::popup>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::elm_popup_item_append_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_popup_item_append);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_popup_align_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_popup_align_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_popup_align_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_popup_align_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_popup_allow_events_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_popup_allow_events_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_popup_allow_events_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_popup_allow_events_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_popup_content_text_wrap_type_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_popup_content_text_wrap_type_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_popup_content_text_wrap_type_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_popup_content_text_wrap_type_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_popup_orient_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_popup_orient_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_popup_orient_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_popup_orient_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_popup_timeout_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_popup_timeout_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_popup_timeout_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_popup_timeout_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_popup_scrollable_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_popup_scrollable_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_popup_scrollable_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_popup_scrollable_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::elm::layout>(), &ops[operation_description_class_size< ::elm::popup >::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::elm_interface_atspi_widget_action>(), &ops[operation_description_class_size< ::elm::popup >::value + operation_description_class_size<::elm::layout>::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm::popup>)
{
   return (ELM_POPUP_CLASS);
}

} } }

/// @endcond

